﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace watki
{
    class Block
    {
        private double lambda_k=1.0;
        private double[] x0;
        private double[] x1;
        private double[][] A;
        private double[] a2;
        private int[][] indexes;
        private double[] p;
        int numberOfEquation;
        int numberOfPixels=0;
        public int NumberOfPixels {
            get { return numberOfPixels; }
        }
        double[][] multiX1;
        int[] graniceBlokow;
        public Block(double[] x0,double[][] A, int[][] indexes, double[] p)
        {
            this.x0 = x0;
            x1 = new double[x0.Length];
            for (int i = 0; i < x1.Length; i++)
                x1[i] = 0.0;
            this.A = A;
            this.indexes = indexes;
            //sprawdzenie ile jest wszystkich pikseli
            for (int i = 0; i < indexes.Length;i++)
                for (int j = 0; j < indexes[i].Length; j++)
                    if (numberOfPixels < indexes[i][j])
                        numberOfPixels = indexes[i][j];
            //zwiększenie o jeden bo indeksowanie jest od zera
            numberOfPixels++;
            Console.WriteLine("Ilosc pikseli {0}", numberOfPixels);
            this.p = p;
            numberOfEquation = p.Length;
            a2 = new double[numberOfEquation];
            CalculateA2();
        }
        private void CalculateA2()
        {
            for(int i=0;i<numberOfEquation;i++)
            {
                var numberOfPixesles = indexes[i].Length;
                a2[i] = 0.0;
                for (int j = 0; j < numberOfPixesles; j++)
                {
                    a2[i] += A[i][j] * A[i][j];
                }
            }

        }
        public double[] Solve(double lambda_k, int numberOfIterations)
        {
            //CalculateA2();
            double tmp = 0.0;
            double[] x1 = new double[numberOfPixels];

            for (int i = 0; i < numberOfPixels; i++)
                x1[i] = x0[i];



            for (int iter = 0; iter < numberOfIterations; iter++)
            { 
                for (int i = 0; i < numberOfEquation; i++)
                {
                    
                    int numberOfPixels = indexes[i].Length;
                    tmp = p[i];
                    for (int k = 0; k < numberOfPixels; k++)
                    {
                        tmp -= A[i][k] * x1[indexes[i][k]];
                    }
                    tmp = tmp / a2[i];

                    for (int k = 0; k < numberOfPixels; k++)
                        x1[indexes[i][k]] += lambda_k * tmp * A[i][k];
                    
                }
                for (int i = 0; i < numberOfPixels; i++)
                    if (x1[i] < 0.0) x1[i] = 0.0;
            }

            return x1;
        }

        private void SolveInTask(int indexOfTask)
        {
            int startEquation = graniceBlokow[indexOfTask];
            int StopEquation = graniceBlokow[indexOfTask+1];
            //for(int it = 0; it < 1000; it++)
            //{ 
            double tmp = 0.0;
                for (int i = startEquation; i < StopEquation; i++)
                {
                    int numberOfPixels = indexes[i].Length;
                    tmp = p[i];
                    for (int k = 0; k < numberOfPixels; k++)
                    {
                        tmp -= A[i][k] * multiX1[indexOfTask][indexes[i][k]];
                    }
                    tmp = tmp / a2[i];

                    for (int k = 0; k < numberOfPixels; k++)
                        multiX1[indexOfTask][indexes[i][k]] += lambda_k * tmp * A[i][k];

                }   
            //}
            //Console.WriteLine("poiczona {0}",indexOfTask);
        }

        


        public double[] MultiTaskSolve(double[] x0, double lambda_k, int numberOfIterations, int numberOfTasks)
        {
            //CalculateA2();

            multiX1 = new double[numberOfTasks][];// numberOfPixels];

            for (int i = 0; i < numberOfTasks; i++)
            {
                multiX1[i] = new double[numberOfPixels];
                for (int j = 0; j < numberOfPixels; j++)
                {
                    multiX1[i][j] = x0[j];
                }
            }
            int numerOfEquationsForOneTask = numberOfEquation / numberOfTasks;

            int reszta = numberOfEquation % numberOfTasks;

            graniceBlokow = new int[numberOfTasks+1];
            graniceBlokow[0] = 0;
            var granica = numerOfEquationsForOneTask;
            var biezacaReszta = reszta;


            for (int i = 0; i < numberOfTasks; i++)
            {
                if (biezacaReszta >= numberOfTasks)
                {
                    granica += 1;
                    biezacaReszta -= numberOfTasks;
                    
                }
                graniceBlokow[i+1] = granica;
                granica += numerOfEquationsForOneTask;
                biezacaReszta += reszta;
            }



            Console.WriteLine("ilosc rownań na watek {0} {1}", numerOfEquationsForOneTask, numberOfEquation % numberOfTasks);

            var countOfPixelsInBloks =new int[numberOfTasks,numberOfPixels];
            int currentEquation = 0;

            for (int itTask = 0; itTask < numberOfTasks; itTask++)
            {
                while (currentEquation < graniceBlokow[itTask+1])
                {
                    int k = indexes[currentEquation].Length;
                       for(int j=0;j< k;j++)
                       countOfPixelsInBloks[itTask, indexes[currentEquation][j]] += 1;
                    currentEquation++;
                }
            }

            var countOfPixels = new int[numberOfPixels];
            for (int it = 0; it < numberOfTasks; it++)
                for (int itP = 0; itP < numberOfPixels; itP++)
                    countOfPixels[itP] += countOfPixelsInBloks[it, itP];

            double[,] weights = new double[numberOfTasks, numberOfPixels];

            for (int it = 0; it < numberOfTasks; it++)
                for (int itP = 0; itP < numberOfPixels; itP++)
                {
                    weights[it, itP] = (1.0 * countOfPixelsInBloks[it, itP]) / countOfPixels[itP];
                }


            //TaskFactory taskFactory = new TaskFactory();

            var tasks = new Task[numberOfTasks];
            Action<object> action = (object o) => { SolveInTask((int)o); };
            /////////////

            for (int iter=0;iter<numberOfIterations;iter++)
            { 
            for (int i = 0; i < numberOfTasks; i++)
            {


                    //tasks.Add(new Task(action,i));

                    //tasks[i] = new Task(action, i);
                    tasks[i] = Task.Factory.StartNew(action,i);
                    
            }
            Task.WaitAll(tasks);
                
                for (int i = 0; i < numberOfPixels; i++)
                {
                    x1[i] = 0.0;
                    for (int j = 0; j < numberOfTasks; j++)
                    {
                        x1[i] += multiX1[j][i] * weights[j, i];
                    }
                    if (x1[i] < 0.0) x1[i] = 0.0;

                    for (int j = 0; j < numberOfTasks; j++)
                    {
                        multiX1[j][i] = x1[i];
                    }
                }
                //Console.WriteLine("");
            }
            

                    return x1;
        }

    }
}
