﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace watki
{
    public partial class Form1 : Form
    {
        string path = "";
        double[][] A;
        int[][] Indexes;
        int maxIndex = 0;
        double[] p;
        bool CzyWczytane = false;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Zadania zadania = new Zadania(100);
            
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ReadingData readingData = ReadingData.Instance;

             p = readingData.ReadVerctor();
             A=readingData.ReadMatrix1();
            var x0 = new double[240*240];
            for (int i = 0; i < x0.Length; i++)
                x0[i] = 0.0;
            Block block = new Block(x0, A, readingData.Indexes,p);
            var start = Environment.TickCount;
            var result=block.Solve(1.0,500);
            var stop = Environment.TickCount;
            Console.WriteLine("czas jednego wątku {0}", stop - start);

            int k = 0; int nP = (int)Math.Sqrt(block.NumberOfPixels);
            for (int i = 0; i < nP; i++)
            {
                for (int j = 0; j < nP; j++)
                {
                    Console.Write("{0} ", result[k] < 0.2 ? 0 : result[k] > 0.8 ? 1 : result[k]);
                    k++;
                }
                Console.WriteLine("");
            }
            start = Environment.TickCount;
            result=block.MultiTaskSolve(x0,1.0, 500, 3);
            stop = Environment.TickCount;
            Console.WriteLine("czas wielu watków {0}",stop-start);
             k = 0;
            for (int i = 0; i < nP; i++)
            {
                for (int j = 0; j < nP; j++)
                {
                    Console.Write("{0} ", result[k] < 0.2 ? 0 : result[k] > 0.8 ? 1 : result[k]);
                    k++;
                }
                Console.WriteLine("");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string napis = "1.3E-16";
            double x = double.Parse(napis);
            Console.WriteLine("x={0}",x<1.0E-5?0:x);
        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            ReadingData data = ReadingData.Instance;
            data.ReadMatrix1();
        }

        private void wybierzFolderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string selectedVectorFileName = openFileDialog1.FileName;
                path = System.IO.Path.GetDirectoryName(selectedVectorFileName);
                ReadingData reader = ReadingData.Instance;
                //wczytanie danych z wielu plików
                 p = reader.ReadVerctor(selectedVectorFileName);
                 A = reader.ReadingMatrixFromFiles(path);
                 Indexes = reader.Indexes;
                maxIndex=0;
                foreach (var line in Indexes)
                {
                    int n = line.Length;
                    foreach (var i in line)
                    {
                        if (i > maxIndex) maxIndex = i;
                    }
                }
                CzyWczytane = true;
                //punkt startowy
                

                textBox1.Text = $"Ilość pikseli: {maxIndex+1}{Environment.NewLine}";
                textBox1.Text += $"Ilość wierszy w macierzy: {A.Length}{Environment.NewLine}";
                textBox1.Text += $"Ilość wierszy w wyktorze: {p.Length}";

                button4.Enabled = true;
                button5.Enabled = true;




            }
               
        }

        private void plikiToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (CzyWczytane)
            {
                double[] x0 = new double[maxIndex + 1];
                for (int i = 0; i < maxIndex + 1; i++)
                    x0[i] = 0.0;
                textBox1.Text+=$"{Environment.NewLine}lambda={numericUpDown1.Value}{Environment.NewLine}";

                Block block = new Block(x0, A, Indexes, p);
                var start = Environment.TickCount;
                var result = block.Solve((double)numericUpDown1.Value, 300);
                var stop = Environment.TickCount;
                textBox1.Text += $"Czas liczenia {(stop-start)/1000.0} [s]";

                int n = (int)Math.Sqrt(maxIndex+1);
                var wynikiS = new string[n];
                int index = 0;
                for (int i = 0; i < maxIndex; i++)
                {
                    wynikiS[index] +=result[i].ToString("f5")+" ";
                    // (result[i]<0.2?0:(result[i]>0.5?1:0.5)) + " ";
                    if (i % n==0 && i > 0) index++;
                }

               System.IO.File.WriteAllLines(path + "\\wynik.txt",wynikiS);

                
                    

               
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            double[] x0 = new double[maxIndex + 1];
            for (int i = 0; i < maxIndex + 1; i++)
                x0[i] = 0.0;
            textBox1.Text += $"{Environment.NewLine}lambda={numericUpDown1.Value}{Environment.NewLine}";

            Block block = new Block(x0, A, Indexes, p);
            var start = Environment.TickCount;
            var result = block.MultiTaskSolve(x0, 1.0, 500, 2);
            var stop = Environment.TickCount;
            textBox1.Text += $"Czas liczenia {(stop - start) / 1000.0} [s]";

            int n = (int)Math.Sqrt(maxIndex + 1);
            var wynikiS = new string[n];
            int index = 0;
            for (int i = 0; i < maxIndex; i++)
            {
                wynikiS[index] += result[i].ToString("f5") + " ";
                // (result[i]<0.2?0:(result[i]>0.5?1:0.5)) + " ";
                if (i % n == 0 && i > 0) index++;
            }

            System.IO.File.WriteAllLines(path + "\\wynik_res.txt", wynikiS);


            
        }
    }
}
