﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace watki
{
    class ReadingData
    {
        double[][] Matrix { get; set; }
        public int[][] Indexes { get; set; }

        //private struct Pair
        //{
        //    public int Index { get; set; }
        //    public double Value { get; set; }

        //}

        #region FIELD
        private static string matrixFileName = DataInfo.MatrixFileName;
        private static string vectorFileName = DataInfo.VectorFileName;
        private static ReadingData instance = null;
        #endregion


        public static ReadingData Instance
        {

            get
            {

                return instance ?? (instance = new ReadingData());

            }
        }

        private ReadingData()
        {

        }

        public double[] ReadVerctor(string path="")
        {
            if (path != "")
            {
                vectorFileName = path;
            }
            if (System.IO.File.Exists(vectorFileName))
            {
                int n = 0;
                var vectorString = System.IO.File.ReadAllText(vectorFileName);

                vectorString = vectorString.Remove(0, 1);
                vectorString = vectorString.Remove(vectorString.Length - 1);
                vectorString = vectorString.Replace("*10^", "E");
                vectorString = vectorString.Replace("*^", "E");

                string[] numbersString = vectorString.Split(',');
                double[] numbers = new double[n = numbersString.Length];
                for (int i = 0; i < n; i++)
                    numbers[i] = double.Parse(numbersString[i].Replace("\\\r\n", ""));
                return numbers;
            }
            else
                throw new Exception("File doesn't exist");


        }

        public double[][] ReadMatrix(string matrixFileName)
        {
            
            if (System.IO.File.Exists(matrixFileName))
            {
                int n = 0;
                var matrixString = System.IO.File.ReadAllText(matrixFileName);
                matrixString = matrixString.Replace("*10^", "E");
                matrixString = matrixString.Replace("*^", "E");

                matrixString = matrixString.Remove(0, 1);
                matrixString = matrixString.Remove(matrixString.Length - 1);
                matrixString = matrixString.Replace(" ", "");
                var lines = matrixString.Split(new string[] { "}}," }, StringSplitOptions.None);

                n = lines.Length;
                for (int ii = 0; ii < lines.Length; ii++)
                {
                    lines[ii] = lines[ii].Remove(0, 1);
                    lines[ii] = lines[ii] + "}";
                }

                Matrix = new double[n][];
                Indexes = new int[n][];
                int i = 0;
                for (; i < n - 1; i++)
                {
                    var element1 = lines[i].Split(',');
                    int m1 = (element1.Length);
                    Matrix[i] = new double[m1 / 2];
                    Indexes[i] = new int[m1 / 2];
                    int z1 = 0;
                    for (int j = 0; j < m1; j += 2)
                    {
                        Indexes[i][z1] = int.Parse(element1[j].Remove(0, 1)) - 1;
                        Matrix[i][z1++] = double.Parse(element1[j + 1].Remove(element1[j + 1].Length - 1));
                    }
                }
                var element = lines[i].Split(',');
                int m = element.Length;

                element[m - 1] = element[m - 1].Remove(element[m - 1].Length - 3, 2);

                Matrix[i] = new double[m / 2];
                Indexes[i] = new int[m / 2];
                int z = 0;
                for (int j = 0; j < m; j += 2)
                {
                    Indexes[i][z] = int.Parse(element[j].Remove(0, 1)) - 1;
                    Matrix[i][z++] = double.Parse(element[j + 1].Remove(element[j + 1].Length - 1));
                }


                //Console.WriteLine(lines[0]);

                //Console.WriteLine(lines.Length);
            }
            else
                throw new Exception("File doesn't exist");
            return Matrix;
        }


        public double[][] ReadMatrix1()
        {
            List<double[]> wiersze=new List<double[]>();
            List<int[]> indeksy = new List<int[]>();
            if (System.IO.File.Exists(matrixFileName))
            {
                int n = 0;
                using (System.IO.StreamReader sReader = new System.IO.StreamReader(matrixFileName))
                {
                    while (!sReader.EndOfStream)
                    {
                        //int znak;
                        //while ((znak = sReader.Read()) != 13)
                        //    Console.Write((char)znak);
                        var line = sReader.ReadLine();
                        if (line[0] == ' ') line = line.Remove(0, 1);
                        var numbers = line.Split(' ');
                        int m = numbers.Length;
                        wiersze.Add(new double[m/2]);
                        indeksy.Add(new int[m/2]);
                        int z = 0;
                        for (int i = 0; i < m; i+=2)
                        {
                            indeksy[n][z] = int.Parse(numbers[i])-1;
                            wiersze[n][z++] =double.Parse(numbers[i+1].Replace("*^","E"));
                        }

                        n++;
                    }
                }
                Matrix = wiersze.ToArray();
                Indexes = indeksy.ToArray();
                //    int i = 0;
                //    for (; i < n - 1; i++)
                //    {
                //        var element1 = lines[i].Split(',');
                //        int m1 = (element1.Length);
                //        Matrix[i] = new double[m1 / 2];
                //        Indexes[i] = new int[m1 / 2];
                //        int z1 = 0;
                //        for (int j = 0; j < m1; j += 2)
                //        {
                //            Indexes[i][z1] = int.Parse(element1[j].Remove(0, 1)) - 1;
                //            Matrix[i][z1++] = double.Parse(element1[j + 1].Remove(element1[j + 1].Length - 1));
                //        }
                //    }
                //    var element = lines[i].Split(',');
                //    int m = element.Length;

                //    element[m - 1] = element[m - 1].Remove(element[m - 1].Length - 3, 2);

                //    Matrix[i] = new double[m / 2];
                //    Indexes[i] = new int[m / 2];
                //    int z = 0;
                //    for (int j = 0; j < m; j += 2)
                //    {
                //        Indexes[i][z] = int.Parse(element[j].Remove(0, 1)) - 1;
                //        Matrix[i][z++] = double.Parse(element[j + 1].Remove(element[j + 1].Length - 1));
                //    }


                //    Console.WriteLine(lines[0]);

                //    Console.WriteLine(lines.Length);

                return Matrix;

            }
            else
                throw new Exception("File doesn't exist");


        }

        public double[][] ReadingMatrixFromFiles(string path)
        {
            double[] currentMatrix;
            int[] currentIndexes;

            var dirs = System.IO.Directory.GetFiles(path);
            //wczytanie macierzy z wielu plików
            int count = 0;
            for (int i = 0; i < dirs.Length; i++)
                if (System.IO.Path.GetFileName(dirs[i]).StartsWith("matrix")) count++;
            var dir = System.IO.Path.GetDirectoryName(dirs[0]);
            var matrixes = new List<double[][]>();
            List<double[]> matrix = new List<double[]>();
            List<int[]> indexes = new List<int[]>();
            for (int mm = 1; mm <= count; mm++)
            {
                string currentMatrixFileName = dir + "\\matrix_" + mm + ".txt";
                if (System.IO.File.Exists(currentMatrixFileName))
                {
                    int n = 0;
                    var matrixString = System.IO.File.ReadAllText(currentMatrixFileName);
                    matrixString = matrixString.Replace("*10^", "E");
                    matrixString = matrixString.Replace("*^", "E");

                    matrixString = matrixString.Remove(0, 1);
                    matrixString = matrixString.Remove(matrixString.Length - 1);
                    matrixString = matrixString.Replace(" ", "");
                    var lines = matrixString.Split(new string[] { "}}," }, StringSplitOptions.None);

                    n = lines.Length;
                    for (int ii = 0; ii < lines.Length; ii++)
                    {
                        lines[ii] = lines[ii].Remove(0, 1);
                        lines[ii] = lines[ii] + "}";
                    }

                    //Matrix = new double[n][];
                    //Indexes = new int[n][];
                    int i = 0;
                    for (; i < n - 1; i++)
                    {
                        var element1 = lines[i].Split(',');
                        int m1 = (element1.Length);
                        //Matrix[i] = new double[m1 / 2];
                        //Indexes[i] = new int[m1 / 2];
                        currentMatrix= new double[m1 / 2];
                        currentIndexes= new int[m1 / 2];
                        int z1 = 0;
                        for (int j = 0; j < m1; j += 2)
                        {
                            currentIndexes[z1] = int.Parse(element1[j].Remove(0, 1)) - 1;
                            currentMatrix[z1++] = double.Parse(element1[j + 1].Remove(element1[j + 1].Length - 1));
                        }
                        //dodac do listy
                        matrix.Add(currentMatrix);
                        indexes.Add(currentIndexes);
                    }

                    var element = lines[i].Split(',');
                    int m = element.Length;

                    element[m - 1] = element[m - 1].Remove(element[m - 1].Length - 3, 2);

                     currentMatrix = new double[m / 2];
                     currentIndexes = new int[m / 2];
                    int z = 0;
                    for (int j = 0; j < m; j += 2)
                    {
                        currentIndexes[z] = int.Parse(element[j].Remove(0, 1)) - 1;
                        currentMatrix[z++] = double.Parse(element[j + 1].Remove(element[j + 1].Length - 1));
                    }
                    matrix.Add(currentMatrix);
                    indexes.Add(currentIndexes);
                }

                //matrixes.Add(this.ReadMatrix(dir+"\\matrix_"+i+".txt"));
                //Console.WriteLine($"{i}");
            }

            Indexes = indexes.ToArray();
            Console.WriteLine("OK");





            return matrix.ToArray();
        }


    }
}
